Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendCOM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendCOM.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendCOM.cpp	(revision 56165)
@@ -209,5 +209,5 @@
         case KDeviceType_Floppy:       return QApplication::translate("VBoxGlobal", "Floppy", "DeviceType");
         case KDeviceType_DVD:          return QApplication::translate("VBoxGlobal", "Optical", "DeviceType");
-        case KDeviceType_HardDisk:     return QApplication::translate("VBoxGlobal", "Hard Disk", "DeviceType");
+        case KDeviceType_HardDisk:     return QApplication::translate("VBoxGlobal", "Hard Drive", "DeviceType");
         case KDeviceType_Network:      return QApplication::translate("VBoxGlobal", "Network", "DeviceType");
         case KDeviceType_USB:          return QApplication::translate("VBoxGlobal", "USB", "DeviceType");
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 56165)
@@ -650,11 +650,11 @@
                       tr("<p>You are about to remove following virtual machines from the machine list:</p>"
                          "<p>%1</p>"
-                         "<p>Would you like to delete the files containing the virtual machine from your hard disk as well? "
-                         "Doing this will also remove the files containing the machine's virtual hard disks "
+                         "<p>Would you like to delete the files containing the virtual machine from your hard drive as well? "
+                         "Doing this will also remove the files containing the machine's virtual hard drives "
                          "if they are not in use by another machine.</p>")
                          .arg(strMachineNames) :
                       tr("<p>You are about to remove following virtual machines from the machine list:</p>"
                          "<p>%1</p>"
-                         "<p>Would you like to delete the files containing the virtual machine from your hard disk as well?</p>")
+                         "<p>Would you like to delete the files containing the virtual machine from your hard drive as well?</p>")
                          .arg(strMachineNames);
 
@@ -697,6 +697,5 @@
 {
     return questionBinary(0, MessageType_Warning,
-                          tr("<p>One or more virtual hard disks, optical or "
-                             "floppy disk image files are not currently accessible. As a result, you will "
+                          tr("<p>One or more disk image files are not currently accessible. As a result, you will "
                              "not be able to operate virtual machines that use these files until "
                              "they become accessible later.</p>"
@@ -844,5 +843,5 @@
 {
     return questionBinary(0, MessageType_Question,
-                          tr("<p>Deleting the snapshot will cause the state information saved in it to be lost, and disk data spread over "
+                          tr("<p>Deleting the snapshot will cause the state information saved in it to be lost, and storage data spread over "
                              "several image files that VirtualBox has created together with the snapshot will be merged into one file. "
                              "This can be a lengthy process, and the information in the snapshot cannot be recovered.</p>"
@@ -859,6 +858,6 @@
 {
     return questionBinary(0, MessageType_Question,
-                          tr("<p>Deleting the snapshot %1 will temporarily need more disk space. In the worst case the size of image %2 will grow by %3, "
-                              "however on this filesystem there is only %4 free.</p><p>Running out of disk space during the merge operation can result in "
+                          tr("<p>Deleting the snapshot %1 will temporarily need more storage space. In the worst case the size of image %2 will grow by %3, "
+                              "however on this filesystem there is only %4 free.</p><p>Running out of storage space during the merge operation can result in "
                               "corruption of the image and the VM configuration, i.e. loss of the VM and its data.</p><p>You may continue with deleting "
                               "the snapshot at your own risk.</p>")
@@ -1064,9 +1063,9 @@
 {
     return questionTrinary(pParent, MessageType_Question,
-                           tr("<p>You are about to add a virtual hard disk to controller <b>%1</b>.</p>"
-                              "<p>Would you like to create a new, empty file to hold the disk contents or select an existing one?</p>")
+                           tr("<p>You are about to add a virtual hard drive to controller <b>%1</b>.</p>"
+                              "<p>Would you like to create a new, empty file to hold the drive contents or select an existing one?</p>")
                               .arg(strControllerName),
                            0 /* auto-confirm id */,
-                           tr("Create &new disk"), tr("&Choose existing disk"));
+                           tr("Create &new drive"), tr("&Choose existing drive"));
 }
 
@@ -1112,5 +1111,5 @@
         case UIMediumType_HardDisk:
         {
-            strMessage = tr("Failed to attach the hard disk (<nobr><b>%1</b></nobr>) to the slot <i>%2</i> of the machine <b>%3</b>.")
+            strMessage = tr("Failed to attach the hard drive (<nobr><b>%1</b></nobr>) to the slot <i>%2</i> of the machine <b>%3</b>.")
                             .arg(strLocation).arg(gpConverter->toString(storageSlot)).arg(CMachine(machine).GetName());
             break;
@@ -1240,5 +1239,5 @@
         case UIMediumType_HardDisk:
         {
-            strMessage = tr("<p>Are you sure you want to release the virtual hard disk <nobr><b>%1</b></nobr>?</p>"
+            strMessage = tr("<p>Are you sure you want to release the virtual hard drive <nobr><b>%1</b></nobr>?</p>"
                             "<p>This will detach it from the following virtual machine(s): <b>%2</b>.</p>");
             break;
@@ -1274,5 +1273,5 @@
         case UIMediumType_HardDisk:
         {
-            strMessage = tr("<p>Are you sure you want to remove the virtual hard disk "
+            strMessage = tr("<p>Are you sure you want to remove the virtual hard drive "
                             "<nobr><b>%1</b></nobr> from the list of known disk image files?</p>");
             /* Compose capabilities flag: */
@@ -1286,5 +1285,5 @@
             {
                 if (medium.state() == KMediumState_Inaccessible)
-                    strMessage += tr("<p>As this hard disk is inaccessible its image file"
+                    strMessage += tr("<p>As this hard drive is inaccessible its image file"
                                      " can not be deleted.</p>");
             }
@@ -1320,5 +1319,5 @@
 {
     return questionTrinary(pParent, MessageType_Question,
-                           tr("<p>Do you want to delete the storage unit of the hard disk "
+                           tr("<p>Do you want to delete the storage unit of the hard drive "
                               "<nobr><b>%1</b></nobr>?</p>"
                               "<p>If you select <b>Delete</b> then the specified storage unit "
@@ -1359,5 +1358,5 @@
         case UIMediumType_HardDisk:
         {
-            strMessage = tr("Failed to detach the hard disk (<nobr><b>%1</b></nobr>) from the slot <i>%2</i> of the machine <b>%3</b>.")
+            strMessage = tr("Failed to detach the hard drive (<nobr><b>%1</b></nobr>) from the slot <i>%2</i> of the machine <b>%3</b>.")
                             .arg(strLocation, gpConverter->toString(storageSlot), CMachine(machine).GetName());
             break;
@@ -1436,60 +1435,16 @@
 }
 
-void UIMessageCenter::cannotOpenMedium(const CVirtualBox &vbox, UIMediumType type, const QString &strLocation, QWidget *pParent /* = 0*/) const
-{
-    /* Prepare the message: */
-    QString strMessage;
-    switch (type)
-    {
-        case UIMediumType_HardDisk:
-        {
-            strMessage = tr("Failed to open the hard disk file <nobr><b>%1</b></nobr>.");
-            break;
-        }
-        case UIMediumType_DVD:
-        {
-            strMessage = tr("Failed to open the optical disk file <nobr><b>%1</b></nobr>.");
-            break;
-        }
-        case UIMediumType_Floppy:
-        {
-            strMessage = tr("Failed to open the floppy disk file <nobr><b>%1</b></nobr>.");
-            break;
-        }
-        default:
-            break;
-    }
+void UIMessageCenter::cannotOpenMedium(const CVirtualBox &vbox, UIMediumType /* type */, const QString &strLocation, QWidget *pParent /* = 0*/) const
+{
     /* Show the error: */
     error(pParent, MessageType_Error,
-          strMessage.arg(strLocation), formatErrorInfo(vbox));
+          tr("Failed to open the disk image file <nobr><b>%1</b></nobr>.").arg(strLocation), formatErrorInfo(vbox));
 }
 
 void UIMessageCenter::cannotCloseMedium(const UIMedium &medium, const COMResult &rc, QWidget *pParent /* = 0*/) const
 {
-    /* Prepare the message: */
-    QString strMessage;
-    switch (medium.type())
-    {
-        case UIMediumType_HardDisk:
-        {
-            strMessage = tr("Failed to close the hard disk file <nobr><b>%2</b></nobr>.");
-            break;
-        }
-        case UIMediumType_DVD:
-        {
-            strMessage = tr("Failed to close the optical disk file <nobr><b>%2</b></nobr>.");
-            break;
-        }
-        case UIMediumType_Floppy:
-        {
-            strMessage = tr("Failed to close the floppy disk file <nobr><b>%2</b></nobr>.");
-            break;
-        }
-        default:
-            break;
-    }
     /* Show the error: */
     error(pParent, MessageType_Error,
-          strMessage.arg(medium.location()), formatErrorInfo(rc));
+          tr("Failed to close the disk image file <nobr><b>%1</b></nobr>.").arg(medium.location()), formatErrorInfo(rc));
 }
 
@@ -1540,7 +1495,7 @@
 {
     alert(pParent, MessageType_Info,
-          tr("<p>The hard disk storage unit at location <b>%1</b> already exists. "
-             "You cannot create a new virtual hard disk that uses this location "
-             "because it can be already used by another virtual hard disk.</p>"
+          tr("<p>The hard drive storage unit at location <b>%1</b> already exists. "
+             "You cannot create a new virtual hard drive that uses this location "
+             "because it can be already used by another virtual hard drive.</p>"
              "<p>Please specify a different location.</p>")
              .arg(strLocation));
@@ -1550,5 +1505,5 @@
 {
     error(pParent, MessageType_Error,
-          tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
+          tr("Failed to create the hard drive storage <nobr><b>%1</b>.</nobr>")
              .arg(strLocation),
           formatErrorInfo(vbox));
@@ -1558,5 +1513,5 @@
 {
     error(pParent, MessageType_Error,
-          tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
+          tr("Failed to create the hard drive storage <nobr><b>%1</b>.</nobr>")
              .arg(strLocation),
           formatErrorInfo(medium));
@@ -1566,5 +1521,5 @@
 {
     error(pParent, MessageType_Error,
-          tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
+          tr("Failed to create the hard drive storage <nobr><b>%1</b>.</nobr>")
              .arg(strLocation),
           formatErrorInfo(progress));
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 56165)
@@ -1786,18 +1786,5 @@
     pActionOpenExistingMedium->setData(QVariant::fromValue(UIMediumTarget(strControllerName, currentAttachment.GetPort(), currentAttachment.GetDevice(),
                                                                           mediumType)));
-    switch (mediumType)
-    {
-        case UIMediumType_HardDisk:
-            pActionOpenExistingMedium->setText(QApplication::translate("UIMachineSettingsStorage", "Choose a virtual hard disk file..."));
-            break;
-        case UIMediumType_DVD:
-            pActionOpenExistingMedium->setText(QApplication::translate("UIMachineSettingsStorage", "Choose a virtual optical disk file..."));
-            break;
-        case UIMediumType_Floppy:
-            pActionOpenExistingMedium->setText(QApplication::translate("UIMachineSettingsStorage", "Choose a virtual floppy disk file..."));
-            break;
-        default:
-            break;
-    }
+    pActionOpenExistingMedium->setText(QApplication::translate("UIMachineSettingsStorage", "Choose a virtual disk image file..."));
 
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 56165)
@@ -117,5 +117,5 @@
         QString strToolTip = QApplication::translate("UIIndicatorsPool",
                                                      "<p style='white-space:pre'><nobr>Indicates the activity "
-                                                     "of the virtual hard disks:</nobr>%1</p>", "HDD tooltip");
+                                                     "of the hard drives:</nobr>%1</p>", "HDD tooltip");
         QString strFullData;
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp	(revision 56165)
@@ -412,5 +412,5 @@
                                     "<p>You can use the VirtualBox Manager to return to running the virtual machine in a window.</p>"));
     m_pSaveRadio->setText(tr("&Save the machine state"));
-    m_pSaveRadio->setWhatsThis(tr("<p>Saves the current execution state of the virtual machine to the physical hard disk of the host PC.</p>"
+    m_pSaveRadio->setWhatsThis(tr("<p>Saves the current execution state of the virtual machine to the physical hard drive of the host PC.</p>"
                                   "<p>Next time this machine is started, it will be restored from the saved state and continue execution "
                                   "from the same place you saved it at, which will let you continue your work immediately.</p>"
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp	(revision 56165)
@@ -479,5 +479,5 @@
     mPsSnapshot->setWhatsThis(tr("Holds the path where snapshots of this "
                                  "virtual machine will be stored. Be aware that "
-                                 "snapshots can take quite a lot of disk space."));
+                                 "snapshots can take quite a lot of storage space."));
     /* Translate Shared Clipboard mode combo: */
     AssertPtrReturnVoid(mCbClipboard);
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.ui	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.ui	(revision 56165)
@@ -379,5 +379,5 @@
             </property>
             <property name="whatsThis">
-             <string>When checked, the guest system will see the virtual disk as a solid state device.</string>
+             <string>When checked, the guest system will see the virtual drive as a solid-state device.</string>
             </property>
             <property name="text">
@@ -395,5 +395,5 @@
             </property>
             <property name="whatsThis">
-             <string>When checked, the guest system will see the virtual disk as a hot-pluggable device.</string>
+             <string>When checked, the guest system will see the virtual drive as a hot-pluggable device.</string>
             </property>
             <property name="text">
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 56164)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 56165)
@@ -214,8 +214,8 @@
                     case KVirtualSystemDescriptionType_CPU:                    v = UIApplianceEditorWidget::tr("CPU"); break;
                     case KVirtualSystemDescriptionType_Memory:                 v = UIApplianceEditorWidget::tr("RAM"); break;
-                    case KVirtualSystemDescriptionType_HardDiskControllerIDE:  v = UIApplianceEditorWidget::tr("Hard Disk Controller (IDE)"); break;
-                    case KVirtualSystemDescriptionType_HardDiskControllerSATA: v = UIApplianceEditorWidget::tr("Hard Disk Controller (SATA)"); break;
-                    case KVirtualSystemDescriptionType_HardDiskControllerSCSI: v = UIApplianceEditorWidget::tr("Hard Disk Controller (SCSI)"); break;
-                    case KVirtualSystemDescriptionType_HardDiskControllerSAS:  v = UIApplianceEditorWidget::tr("Hard Disk Controller (SAS)"); break;
+                    case KVirtualSystemDescriptionType_HardDiskControllerIDE:  v = UIApplianceEditorWidget::tr("Storage Controller (IDE)"); break;
+                    case KVirtualSystemDescriptionType_HardDiskControllerSATA: v = UIApplianceEditorWidget::tr("Storage Controller (SATA)"); break;
+                    case KVirtualSystemDescriptionType_HardDiskControllerSCSI: v = UIApplianceEditorWidget::tr("Storage Controller (SCSI)"); break;
+                    case KVirtualSystemDescriptionType_HardDiskControllerSAS:  v = UIApplianceEditorWidget::tr("Storage Controller (SAS)"); break;
                     case KVirtualSystemDescriptionType_CDROM:                  v = UIApplianceEditorWidget::tr("DVD"); break;
                     case KVirtualSystemDescriptionType_Floppy:                 v = UIApplianceEditorWidget::tr("Floppy"); break;