Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSIDevice.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSIDevice.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSIDevice.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSIInline.h
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSIInline.h	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSIInline.h	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2010 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSIInternal.h
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSIInternal.h	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSIInternal.h	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSIIoReq.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSIIoReq.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSIIoReq.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2011 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSILun.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSILun.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSILun.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSILunMmc.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSILunMmc.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSILunMmc.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSILunSbc.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSILunSbc.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSILunSbc.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSISense.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSISense.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSISense.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSIVpdPagePool.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSIVpdPagePool.cpp	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSIVpdPagePool.cpp	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2011-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/Storage/VSCSI/VSCSIVpdPages.h
===================================================================
--- trunk/src/VBox/Devices/Storage/VSCSI/VSCSIVpdPages.h	(revision 55643)
+++ trunk/src/VBox/Devices/Storage/VSCSI/VSCSIVpdPages.h	(revision 56292)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2011-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as