Index: trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-cocoa.m
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-cocoa.m	(revision 56316)
+++ trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-cocoa.m	(revision 56333)
@@ -36,6 +36,6 @@
 *******************************************************************************/
 /** @def USE_NSOPENGLVIEW
- * Define this to experiment with using NSOpenGLView instead 
- * of NSView.  There are transparency issues with the former, 
+ * Define this to experiment with using NSOpenGLView instead
+ * of NSView.  There are transparency issues with the former,
  * so for the time being we're using the latter.  */
 #if 0
@@ -54,5 +54,5 @@
 @public
     /* in */
-    NativeNSViewRef             pParentView; 
+    NativeNSViewRef             pParentView;
     uint32_t                    cx;
     uint32_t                    cy;
@@ -70,5 +70,5 @@
  * The overlay view.
  */
-@interface VMSVGA3DOverlayView 
+@interface VMSVGA3DOverlayView
 #ifdef USE_NSOPENGLVIEW
     : NSOpenGLView
@@ -90,5 +90,5 @@
     NSPoint          m_Pos;
     NSSize           m_Size;
-    
+
     /** This is necessary for clipping on the root window */
     NSRect           m_RootRect;
@@ -110,5 +110,5 @@
 
 #endif
-/* Overridden: */    
+/* Overridden: */
 - (void)viewDidMoveToWindow;
 - (void)viewDidMoveToSuperview;
@@ -167,6 +167,6 @@
         {
             /*
-             * If we have no shared GL context, we use the one that NSOpenGLView create. Otherwise, 
-             * we replace it.  (If we don't call openGLContext, it won't yet have been instantiated, 
+             * If we have no shared GL context, we use the one that NSOpenGLView create. Otherwise,
+             * we replace it.  (If we don't call openGLContext, it won't yet have been instantiated,
              * so there is no unecessary contexts created here when pSharedCtx != NULL.)
              */
@@ -190,5 +190,5 @@
             if (pCtx)
             {
-                /* 
+                /*
                  * Attach the view to the parent.
                  */
@@ -240,5 +240,5 @@
     m_Size           = frame.size;
     m_RootRect       = NSMakeRect(0, 0, m_Size.width, m_Size.height);
-    
+
 #ifdef USE_NSOPENGLVIEW
     self = [super initWithFrame:frame pixelFormat:pFmt];
@@ -324,5 +324,5 @@
 
     /*
-     * Not doing any complicate stuff here yet, hoping that we'll get correctly 
+     * Not doing any complicate stuff here yet, hoping that we'll get correctly
      * resized when the parent view changes...
      */
@@ -340,8 +340,8 @@
 
 
-/** 
- * Changes to the OpenGL context associated with the view. 
- * @returns Previous OpenGL context. 
- */ 
+/**
+ * Changes to the OpenGL context associated with the view.
+ * @returns Previous OpenGL context.
+ */
 - (NSOpenGLContext *)makeCurrentGLContext
 {
@@ -359,7 +359,7 @@
 
 /**
- * Restores the previous OpenGL context after 
- * makeCurrentGLContext. 
- *  
+ * Restores the previous OpenGL context after
+ * makeCurrentGLContext.
+ *
  * @param pSavedCtx     The makeCurrentGLContext return value.
  */
@@ -415,5 +415,5 @@
 #endif /* USE_NSOPENGLVIEW */
 
-/* 
+/*
  * Overridden NSOpenGLView / NSView methods:
  */
@@ -435,5 +435,5 @@
 -(void)resizeWithOldSuperviewSize:(NSSize)oldBoundsSize
 {
-    LogFlow(("OvlView(%p) resizeWithOldSuperviewSize: %d,%d -> %d,%d\n", (void *)self, 
+    LogFlow(("OvlView(%p) resizeWithOldSuperviewSize: %d,%d -> %d,%d\n", (void *)self,
              (int)oldBoundsSize.width, (int)oldBoundsSize.height, (int)[self bounds].size.width, (int)[self bounds].size.height));
     [super resizeWithOldSuperviewSize:oldBoundsSize];
@@ -474,5 +474,5 @@
                                                            NativeNSOpenGLContextRef pSharedCtx, bool fOtherProfile)
 {
-    LogFlow(("vmsvga3dCocoaCreateViewAndContext: pParentView=%d size=%d,%d pSharedCtx=%p fOtherProfile=%RTbool\n", 
+    LogFlow(("vmsvga3dCocoaCreateViewAndContext: pParentView=%d size=%d,%d pSharedCtx=%p fOtherProfile=%RTbool\n",
              (void *)pParentView, cx, cy, (void *)pSharedCtx, fOtherProfile));
     NSAutoreleasePool *pPool = [[NSAutoreleasePool alloc] init];
@@ -571,5 +571,5 @@
     }
     else
-    	[NSOpenGLContext clearCurrentContext];
+        [NSOpenGLContext clearCurrentContext];
 
     [pPool release];
@@ -599,5 +599,5 @@
     //[pView setNeedsDisplay:YES];
     vmsvga3dCocoaServiceRunLoop();
-    
+
     [pPool release];
     LogFlow(("vmsvga3dCocoaSwapBuffers: returns\n"));
Index: trunk/src/VBox/Devices/Graphics/VBoxSVGA3D.def
===================================================================
--- trunk/src/VBox/Devices/Graphics/VBoxSVGA3D.def	(revision 56316)
+++ trunk/src/VBox/Devices/Graphics/VBoxSVGA3D.def	(revision 56333)
@@ -17,5 +17,5 @@
 
 LIBRARY VBoxSVGA3D
-EXPORTS 
+EXPORTS
     ShaderInitLib
     ShaderDestroyLib
Index: trunk/src/VBox/Devices/Graphics/VBoxSVGA3DObjC.def
===================================================================
--- trunk/src/VBox/Devices/Graphics/VBoxSVGA3DObjC.def	(revision 56316)
+++ trunk/src/VBox/Devices/Graphics/VBoxSVGA3DObjC.def	(revision 56333)
@@ -17,11 +17,11 @@
 
 LIBRARY VBoxSVGA3DObjC
-EXPORTS 
+EXPORTS
     vmsvga3dCocoaServiceRunLoop
     vmsvga3dCocoaCreateViewAndContext
-    vmsvga3dCocoaDestroyViewAndContext             
-    vmsvga3dCocoaViewSetPosition            
-    vmsvga3dCocoaViewSetSize                
-    vmsvga3dCocoaViewMakeCurrentContext     
-    vmsvga3dCocoaSwapBuffers                
+    vmsvga3dCocoaDestroyViewAndContext
+    vmsvga3dCocoaViewSetPosition
+    vmsvga3dCocoaViewSetSize
+    vmsvga3dCocoaViewMakeCurrentContext
+    vmsvga3dCocoaSwapBuffers
 